/* 
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

package org.apache.muse.ws.resource.properties.query.impl;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

import org.apache.muse.core.routing.AbstractMessageHandler;
import org.apache.muse.ws.addressing.soap.SoapFault;
import org.apache.muse.ws.resource.properties.WsrpConstants;

/**
 *
 * QueryHandler is the parser for the WS-ResourceProperties 
 * QueryResourceProperties operation.
 *
 * @author Dan Jemiolo (danj)
 *
 */

public class QueryHandler extends AbstractMessageHandler
{
    public QueryHandler()
    {
        super(WsrpConstants.QUERY_RESOURCE_PROPERTIES_URI, WsrpConstants.QUERY_QNAME);
    }

    public Object[] fromXML(Element xml) 
        throws SoapFault
    {
        QueryRequest query = new QueryRequest(xml);
        return new Object[]{ query.getQuery(), query.getDialect() };
    }

    public Element toXML(Object result)
    {
        QueryResponse query = new QueryResponse((Node[])result);
        return query.toXML();
    }
}
